// Cancella le foglie pari da un albero binario
// (con operatori del libro)
//
// albero d'esempio
//				9
//			
//		13				21
//
//	20		31		19
//

Program cancfoglie;
Type	binalbero = ^bincella;
	nodo = binalbero;
	bincella = record
		valore : Integer;
		sinistro, destro, genitore : nodo
	End;

Var	albero : binalbero;
var	tmp1, tmp2, tmp3, tmp4 : binalbero;

Procedure CreaBinAlbero(Var T: binalbero);
Begin
	T := nil
End;

Function BinAlberoVuoto(Var T:binalbero) : boolean;
Begin
	BinAlberoVuoto := (T = nil)
End;

Function BinRadice(Var T:binalbero) : nodo;
Begin
	BinRadice := T
End;

Function BinPadre(u: nodo; Var T:binalbero) : nodo;
Begin
	BinPadre := u^.genitore;
End;

Function FiglioSinistro(u: nodo; Var T:binalbero) : nodo;
Begin
	FiglioSinistro := u^.sinistro
End;

Function FiglioDestro(u: nodo; Var T:binalbero) : nodo;
Begin
	FiglioDestro := u^.destro
End;

Function SinistroVuoto(u: nodo; Var T:binalbero) : boolean;
Begin
	SinistroVuoto := (u^.sinistro = nil)
End;

Function DestroVuoto(u: nodo; Var T:binalbero) : boolean;
Begin
	DestroVuoto := (u^.destro = nil)
End;

(* concatena due alberi e restituisce in T l'albero risultante *)
Procedure CostrBinAlbero(Var T, U:binalbero; val:integer);
Var w : nodo;
Begin
	new(w);
	w^.sinistro := T;
	w^.destro := U;
	w^.genitore := nil;
	w^.valore := val;
	if T<>nil then T^.genitore:=w;
	if U<>nil then U^.genitore:=w;
	T := w
End;

Procedure BinVisita(u:nodo; Var T:binalbero);
Begin

// prefissa
	write(u^.valore, '   ');

	if not SinistroVuoto(u, T) then BinVisita(FiglioSinistro(u, T), T);

// infissa
//	writeln(u^.valore);

	if not DestroVuoto(u, T) then BinVisita(FiglioDestro(u, T), T);

// postfissa
//	writeln(u^.valore);
End;

Procedure AllocaNodo(Var T:nodo; val : Integer);
Begin
	new(T);
	T^.valore := val;
	T^.sinistro := NIL;
	T^.destro := NIL;
	T^.genitore := NIL;
End;

Procedure CancellaFoglie(Var T:binalbero; Var U:nodo);
var tmp : nodo;
Begin

	writeln(U^.valore);
	if DESTROVUOTO(U, T) and  SINISTROVUOTO(U, T) and (U^.valore mod 2 = 0) then begin
		if BINPADRE(U, T) = nil then T:=nil
		else	if FIGLIOSINISTRO(BINPADRE(U, T), T) = U then
			Begin
				tmp := BINPADRE(U,T);
				tmp^.sinistro := nil
			End else Begin
				tmp := BINPADRE(U,T);
				tmp^.destro := nil
			End;

		dispose(U)
	end
	else Begin

		if not SINISTROVUOTO(U, T) then Begin
			tmp := FIGLIOSINISTRO(U, T);
			CancellaFoglie(T, tmp);
		End;
		
		if not DESTROVUOTO(U, T) then Begin
			tmp := FIGLIODESTRO(U, T);
			CancellaFoglie(T, tmp)		
		End
	End				
End;

Begin
	(* creazione dei nodi foglia *)
	(* nodo 27 *)
	CreaBinAlbero(tmp1);
	AllocaNodo(tmp1, 20);
	(* nodo 31 *)
	CreaBinAlbero(tmp2);
	AllocaNodo(tmp2, 31);
	(* nodo 19 *)
	CreaBinAlbero(tmp3);
	AllocaNodo(tmp3, 19);

	CostrBinAlbero(tmp1, tmp2, 13);
	(* attenzione: cos' cambiato in tmp1 o tmp2? *)

	CreaBinAlbero(tmp4);
	CostrBinAlbero(tmp3, tmp4, 21);
	CostrBinAlbero(tmp1, tmp3, 9);

	albero := tmp1;

	BinVisita(albero, albero); writeln();

	CancellaFoglie(albero, albero);

	BinVisita(albero, albero);
End.
